Index: .hgsubstate
===================================================================
--- .hgsubstate	(revision 3384)
+++ .hgsubstate	(revision 3489)
@@ -1,1 +1,1 @@
-c31c9344137b910b6066bbe1b940636c2247b4c5 inc/libs/clearbricks
+8ed65d7cb6973002c70283716be6f2296bd720c0 inc/libs/clearbricks
Index: admin/_charte.php
===================================================================
--- admin/_charte.php	(revision 3445)
+++ admin/_charte.php	(revision 3499)
@@ -64,5 +64,5 @@
 </head>
 
-<body id="dotclear-admin" class="no-js guideline">
+<body id="dotclear-admin" class="no-js guideline<?php $core->auth->user_prefs->interface->dynfontsize ? ' responsive-font' : ''; ?>">
 	<ul id="prelude">
 		<li><a href="#content">Aller au contenu</a></li>
Index: admin/help.php
===================================================================
--- admin/help.php	(revision 2720)
+++ admin/help.php	(revision 3491)
@@ -15,5 +15,5 @@
 dcPage::check('usage');
 
-function helpPage()
+$helpPage = function()
 {
 	$ret = array('content' => '', 'title' => '');
@@ -66,10 +66,10 @@
 	}
 	return $ret;
-}
+};
 
 $help_page = !empty($_GET['page']) ? html::escapeHTML($_GET['page']) : 'index';
-$content_array = helpPage($help_page);
+$content_array = $helpPage($help_page);
 if (($content_array['content'] == '') || ($help_page == 'index')) {
-	$content_array = helpPage('index');
+	$content_array = $helpPage('index');
 }
 if ($content_array['title'] != '') {
Index: admin/index.php
===================================================================
--- admin/index.php	(revision 3476)
+++ admin/index.php	(revision 3491)
@@ -87,5 +87,5 @@
 
 # Check plugins and themes update from repository
-function dc_check_store_update($mod, $url, $img, $icon)
+$checkStoreUpdate = function($mod, $url, $img, $icon)
 {
 	$repo = new dcStore($mod, $url);
@@ -96,12 +96,12 @@
 		$icon[2] = 'images/menu/'.$img.'-b-update.png';
 	}
-}
+};
 if (isset($__dashboard_icons['plugins'])) {
-	dc_check_store_update($core->plugins, $core->blog->settings->system->store_plugin_url, 'plugins', $__dashboard_icons['plugins']);
+	$checkStoreUpdate($core->plugins, $core->blog->settings->system->store_plugin_url, 'plugins', $__dashboard_icons['plugins']);
 }
 if (isset($__dashboard_icons['blog_theme'])) {
 	$themes = new dcThemes($core);
 	$themes->loadModules($core->blog->themes_path, null);
-	dc_check_store_update($themes, $core->blog->settings->system->store_theme_url, 'blog-theme', $__dashboard_icons['blog_theme']);
+	$checkStoreUpdate($themes, $core->blog->settings->system->store_theme_url, 'blog-theme', $__dashboard_icons['blog_theme']);
 }
 
Index: admin/langs.php
===================================================================
--- admin/langs.php	(revision 3036)
+++ admin/langs.php	(revision 3491)
@@ -31,4 +31,34 @@
 } catch (Exception $e) {}
 
+# Language installation function
+$lang_install = function($file)
+{
+	$zip = new fileUnzip($file);
+	$zip->getList(false,'#(^|/)(__MACOSX|\.svn|\.DS_Store|\.directory|Thumbs\.db)(/|$)#');
+
+	if (!preg_match('/^[a-z]{2,3}(-[a-z]{2})?$/',$zip->getRootDir())) {
+		throw new Exception(__('Invalid language zip file.'));
+	}
+
+	if ($zip->isEmpty() || !$zip->hasFile($zip->getRootDir().'/main.po')) {
+		throw new Exception(__('The zip file does not appear to be a valid Dotclear language pack.'));
+	}
+
+
+	$target = dirname($file);
+	$destination = $target.'/'.$zip->getRootDir();
+	$res = 1;
+
+	if (is_dir($destination)) {
+		if (!files::deltree($destination)) {
+			throw new Exception(__('An error occurred during language upgrade.'));
+		}
+		$res = 2;
+	}
+
+	$zip->unzipAll($target);
+	return $res;
+};
+
 # Delete a language pack
 if ($is_writable && !empty($_POST['delete']) && !empty($_POST['locale_id']))
@@ -81,5 +111,5 @@
 
 		try {
-			$ret_code = dc_lang_install($dest);
+			$ret_code = $lang_install($dest);
 		} catch (Exception $e) {
 			@unlink($dest);
@@ -117,5 +147,5 @@
 
 		try {
-			$ret_code = dc_lang_install($dest);
+			$ret_code = $lang_install($dest);
 		} catch (Exception $e) {
 			@unlink($dest);
@@ -266,32 +296,2 @@
 dcPage::helpBlock('core_langs');
 dcPage::close();
-
-# Language installation function
-function dc_lang_install($file)
-{
-	$zip = new fileUnzip($file);
-	$zip->getList(false,'#(^|/)(__MACOSX|\.svn|\.DS_Store|\.directory|Thumbs\.db)(/|$)#');
-
-	if (!preg_match('/^[a-z]{2,3}(-[a-z]{2})?$/',$zip->getRootDir())) {
-		throw new Exception(__('Invalid language zip file.'));
-	}
-
-	if ($zip->isEmpty() || !$zip->hasFile($zip->getRootDir().'/main.po')) {
-		throw new Exception(__('The zip file does not appear to be a valid Dotclear language pack.'));
-	}
-
-
-	$target = dirname($file);
-	$destination = $target.'/'.$zip->getRootDir();
-	$res = 1;
-
-	if (is_dir($destination)) {
-		if (!files::deltree($destination)) {
-			throw new Exception(__('An error occurred during language upgrade.'));
-		}
-		$res = 2;
-	}
-
-	$zip->unzipAll($target);
-	return $res;
-}
Index: admin/media.php
===================================================================
--- admin/media.php	(revision 3440)
+++ admin/media.php	(revision 3501)
@@ -147,4 +147,142 @@
 	$core->error->add($e->getMessage());
 }
+
+// Local functions
+
+$mediaItemLine = function($f,$i,$query,$table=false)
+{
+	global $core, $page_url, $popup, $select, $post_id, $plugin_id, $page_url_params, $link_type;
+
+	$fname = $f->basename;
+	$file = $query ? $f->relname : $f->basename;
+
+	$class = $table ? '' : 'media-item media-col-'.($i%2);
+
+	if ($f->d) {
+		// Folder
+		$link = $core->adminurl->get('admin.media',array_merge($page_url_params,array('d' => html::sanitizeURL($f->relname) )));
+		if ($f->parent) {
+			$fname = '..';
+			$class .= ' media-folder-up';
+		} else {
+			$class .= ' media-folder';
+		}
+	} else {
+		// Item
+		$params = new ArrayObject(
+			array(
+				'id' => $f->media_id,
+				'plugin_id' => $plugin_id,
+				'popup' => $popup,
+				'select' => $select,
+				'post_id' => $post_id,
+				'link_type' => $link_type
+			)
+		);
+		$core->callBehavior('adminMediaURLParams',$params);
+		$params = (array) $params;
+		$link = $core->adminurl->get(
+			'admin.media.item', $params
+		);
+	}
+
+	$maxchars = 36;
+	if (strlen($fname) > $maxchars) {
+		$fname = substr($fname, 0, $maxchars-4).'...'.($f->d ? '' : files::getExtension($fname));
+	}
+
+	$act = '';
+	if (!$f->d) {
+		if ($select > 0) {
+			if ($select == 1) {
+				// Single media selection button
+				$act .= '<a href="'.$link.'"><img src="images/plus.png" alt="'.__('Select this file').'" '.
+				'title="'.__('Select this file').'" /></a> ';
+			} else {
+				// Multiple media selection checkbox
+				$act .= form::checkbox(array('medias[]', 'media_'.rawurlencode($file)),$file);
+			}
+		} else {
+			// Item
+			if ($post_id) {
+				// Media attachment button
+				$act .=
+				'<a class="attach-media" title="'.__('Attach this file to entry').'" href="'.
+				$core->adminurl->get("admin.post.media",
+					array('media_id' => $f->media_id, 'post_id' => $post_id,'attach' => 1,'link_type' => $link_type)).
+				'">'.
+				'<img src="images/plus.png" alt="'.__('Attach this file to entry').'"/>'.
+				'</a>';
+			}
+			if ($popup) {
+				// Media insertion button
+				$act .= '<a href="'.$link.'"><img src="images/plus.png" alt="'.__('Insert this file into entry').'" '.
+				'title="'.__('Insert this file into entry').'" /></a> ';
+			}
+		}
+	}
+	if ($f->del) {
+		// Deletion button or checkbox
+		if (!$popup && !$f->d) {
+			if ($select < 2) {
+				// Already set for multiple media selection
+				$act .= form::checkbox(array('medias[]', 'media_'.rawurlencode($file)),$file);
+			}
+		} else {
+			$act .= '<a class="media-remove" '.
+			'href="'.html::escapeURL($page_url).
+			'&amp;plugin_id='.$plugin_id.
+			'&amp;d='.rawurlencode($GLOBALS['d']).
+			'&amp;q='.rawurlencode($GLOBALS['q']).
+			'&amp;remove='.rawurlencode($file).'">'.
+			'<img src="images/trash.png" alt="'.__('Delete').'" title="'.__('delete').'" /></a>';
+		}
+	}
+
+	$file_type = explode('/',$f->type);
+	$class_open = 'class="modal-'.$file_type[0].'" ';
+
+	// Render markup
+	if (!$table) {
+		$res =
+		'<div class="'.$class.'"><p><a class="media-icon media-link" href="'.rawurldecode($link).'">'.
+		'<img src="'.$f->media_icon.'" alt="" />'.($query ? $file : $fname).'</a></p>';
+
+		$lst = '';
+		if (!$f->d) {
+			$lst .=
+			'<li>'.$f->media_title.'</li>'.
+			'<li>'.
+			$f->media_dtstr.' - '.
+			files::size($f->size).' - '.
+			'<a '.$class_open.'href="'.$f->file_url.'">'.__('open').'</a>'.
+			'</li>';
+		}
+		$lst .= ($act != '' ? '<li class="media-action">&nbsp;'.$act.'</li>' : '');
+
+		// Show player if relevant
+		if ($file_type[0] == 'audio')
+		{
+			$lst .= '<li>'.dcMedia::audioPlayer($f->type,$f->file_url,$core->adminurl->get("admin.home",array('pf' => 'player_mp3.swf')),null,$core->blog->settings->system->media_flash_fallback,false).'</li>';
+		}
+
+		$res .=	($lst != '' ? '<ul>'.$lst.'</ul>' : '');
+		$res .= '</div>';
+	} else {
+		$res = '<tr class="'.$class.'">';
+		$res .= '<td class="media-action">'.$act.'</td>';
+		$res .= '<td class="maximal" scope="row"><a class="media-flag media-link" href="'.rawurldecode($link).'">'.
+				'<img src="'.$f->media_icon.'" alt="" />'.($query ? $file : $fname).'</a>'.
+				'<br />'.($f->d ? '' : $f->media_title).'</td>';
+		$res .= '<td class="nowrap count">'.($f->d ? '' : $f->media_dtstr).'</td>';
+		$res .= '<td class="nowrap count">'.($f->d ? '' : files::size($f->size).' - '.
+			'<a '.$class_open.'href="'.$f->file_url.'">'.__('open').'</a>').'</td>';
+		$res .= '</tr>';
+	}
+
+	return $res;
+};
+
+// Actions
 
 # Zip download
@@ -268,5 +406,5 @@
 				'name' => $upfile['name'],
 				'size' => $upfile['size'],
-				'html' => mediaItemLine($core->media->getFile($new_file_id),1,$query)
+				'html' => $mediaItemLine($core->media->getFile($new_file_id),1,$query)
 			);
 		} catch (Exception $e) {
@@ -704,7 +842,7 @@
 		{
 			if ($items[$i]->d) {
-				$dlist .= mediaItemLine($items[$i],$j,$query,true);
+				$dlist .= $mediaItemLine($items[$i],$j,$query,true);
 			} else {
-				$flist .= mediaItemLine($items[$i],$j,$query,true);
+				$flist .= $mediaItemLine($items[$i],$j,$query,true);
 			}
 		}
@@ -720,7 +858,7 @@
 		{
 			if ($items[$i]->d) {
-				$dgroup .= mediaItemLine($items[$i],$j,$query);
+				$dgroup .= $mediaItemLine($items[$i],$j,$query);
 			} else {
-				$fgroup .= mediaItemLine($items[$i],$j,$query);
+				$fgroup .= $mediaItemLine($items[$i],$j,$query);
 			}
 		}
@@ -875,137 +1013,2 @@
 
 call_user_func($close_f);
-
-/* ----------------------------------------------------- */
-function mediaItemLine($f,$i,$query,$table=false)
-{
-	global $core, $page_url, $popup, $select, $post_id, $plugin_id, $page_url_params, $link_type;
-
-	$fname = $f->basename;
-	$file = $query ? $f->relname : $f->basename;
-
-	$class = $table ? '' : 'media-item media-col-'.($i%2);
-
-	if ($f->d) {
-		// Folder
-		$link = $core->adminurl->get('admin.media',array_merge($page_url_params,array('d' => html::sanitizeURL($f->relname) )));
-		if ($f->parent) {
-			$fname = '..';
-			$class .= ' media-folder-up';
-		} else {
-			$class .= ' media-folder';
-		}
-	} else {
-		// Item
-		$params = new ArrayObject(
-			array(
-				'id' => $f->media_id,
-				'plugin_id' => $plugin_id,
-				'popup' => $popup,
-				'select' => $select,
-				'post_id' => $post_id,
-				'link_type' => $link_type
-			)
-		);
-		$core->callBehavior('adminMediaURLParams',$params);
-		$params = (array) $params;
-		$link = $core->adminurl->get(
-			'admin.media.item', $params
-		);
-	}
-
-	$maxchars = 36;
-	if (strlen($fname) > $maxchars) {
-		$fname = substr($fname, 0, $maxchars-4).'...'.($f->d ? '' : files::getExtension($fname));
-	}
-
-	$act = '';
-	if (!$f->d) {
-		if ($select > 0) {
-			if ($select == 1) {
-				// Single media selection button
-				$act .= '<a href="'.$link.'"><img src="images/plus.png" alt="'.__('Select this file').'" '.
-				'title="'.__('Select this file').'" /></a> ';
-			} else {
-				// Multiple media selection checkbox
-				$act .= form::checkbox(array('medias[]', 'media_'.rawurlencode($file)),$file);
-			}
-		} else {
-			// Item
-			if ($post_id) {
-				// Media attachment button
-				$act .=
-				'<a class="attach-media" title="'.__('Attach this file to entry').'" href="'.
-				$core->adminurl->get("admin.post.media",
-					array('media_id' => $f->media_id, 'post_id' => $post_id,'attach' => 1,'link_type' => $link_type)).
-				'">'.
-				'<img src="images/plus.png" alt="'.__('Attach this file to entry').'"/>'.
-				'</a>';
-			}
-			if ($popup) {
-				// Media insertion button
-				$act .= '<a href="'.$link.'"><img src="images/plus.png" alt="'.__('Insert this file into entry').'" '.
-				'title="'.__('Insert this file into entry').'" /></a> ';
-			}
-		}
-	}
-	if ($f->del) {
-		// Deletion button or checkbox
-		if (!$popup && !$f->d) {
-			if ($select < 2) {
-				// Already set for multiple media selection
-				$act .= form::checkbox(array('medias[]', 'media_'.rawurlencode($file)),$file);
-			}
-		} else {
-			$act .= '<a class="media-remove" '.
-			'href="'.html::escapeURL($page_url).
-			'&amp;plugin_id='.$plugin_id.
-			'&amp;d='.rawurlencode($GLOBALS['d']).
-			'&amp;q='.rawurlencode($GLOBALS['q']).
-			'&amp;remove='.rawurlencode($file).'">'.
-			'<img src="images/trash.png" alt="'.__('Delete').'" title="'.__('delete').'" /></a>';
-		}
-	}
-
-	$file_type = explode('/',$f->type);
-	$class_open = 'class="modal-'.$file_type[0].'" ';
-
-	// Render markup
-	if (!$table) {
-		$res =
-		'<div class="'.$class.'"><p><a class="media-icon media-link" href="'.rawurldecode($link).'">'.
-		'<img src="'.$f->media_icon.'" alt="" />'.($query ? $file : $fname).'</a></p>';
-
-		$lst = '';
-		if (!$f->d) {
-			$lst .=
-			'<li>'.$f->media_title.'</li>'.
-			'<li>'.
-			$f->media_dtstr.' - '.
-			files::size($f->size).' - '.
-			'<a '.$class_open.'href="'.$f->file_url.'">'.__('open').'</a>'.
-			'</li>';
-		}
-		$lst .= ($act != '' ? '<li class="media-action">&nbsp;'.$act.'</li>' : '');
-
-		// Show player if relevant
-		if ($file_type[0] == 'audio')
-		{
-			$lst .= '<li>'.dcMedia::audioPlayer($f->type,$f->file_url,$core->adminurl->get("admin.home",array('pf' => 'player_mp3.swf')),null,$core->blog->settings->system->media_flash_fallback,false).'</li>';
-		}
-
-		$res .=	($lst != '' ? '<ul>'.$lst.'</ul>' : '');
-		$res .= '</div>';
-	} else {
-		$res = '<tr class="'.$class.'">';
-		$res .= '<td class="media-action">'.$act.'</td>';
-		$res .= '<td class="maximal" scope="row"><a class="media-flag media-link" href="'.rawurldecode($link).'">'.
-				'<img src="'.$f->media_icon.'" alt="" />'.($query ? $file : $fname).'</a>'.
-				'<br />'.($f->d ? '' : $f->media_title).'</td>';
-		$res .= '<td class="nowrap count">'.($f->d ? '' : $f->media_dtstr).'</td>';
-		$res .= '<td class="nowrap count">'.($f->d ? '' : files::size($f->size).' - '.
-			'<a '.$class_open.'href="'.$f->file_url.'">'.__('open').'</a>').'</td>';
-		$res .= '</tr>';
-	}
-
-	return $res;
-}
Index: admin/post.php
===================================================================
--- admin/post.php	(revision 3466)
+++ admin/post.php	(revision 3491)
@@ -471,4 +471,86 @@
 	exit;
 }
+
+# Controls comments or trakbacks capabilities
+$isContributionAllowed = function ($id,$dt,$com=true)
+{
+	global $core;
+
+	if (!$id) {
+		return true;
+	}
+	if ($com) {
+		if (($core->blog->settings->system->comments_ttl == 0) ||
+			(time() - $core->blog->settings->system->comments_ttl*86400 < $dt)) {
+			return true;
+		}
+	} else {
+		if (($core->blog->settings->system->trackbacks_ttl == 0) ||
+			(time() - $core->blog->settings->system->trackbacks_ttl*86400 < $dt)) {
+			return true;
+		}
+	}
+	return false;
+};
+
+# Show comments or trackbacks
+$showComments = function($rs,$has_action,$tb=false)
+{
+	global $core;
+	echo
+	'<div class="table-outer">'.
+	'<table class="comments-list"><tr>'.
+	'<th colspan="2" class="first">'.__('Author').'</th>'.
+	'<th>'.__('Date').'</th>'.
+	'<th class="nowrap">'.__('IP address').'</th>'.
+	'<th>'.__('Status').'</th>'.
+	'<th>'.__('Edit').'</th>'.
+	'</tr>';
+	$comments = array();
+	if (isset($_REQUEST['comments'])) {
+		foreach ($_REQUEST['comments'] as $v) {
+			$comments[(integer)$v]=true;
+		}
+	}
+
+	while($rs->fetch())
+	{
+		$comment_url = $core->adminurl->get("admin.comment",array('id' => $rs->comment_id));
+
+		$img = '<img alt="%1$s" title="%1$s" src="images/%2$s" />';
+		switch ($rs->comment_status) {
+			case 1:
+				$img_status = sprintf($img,__('Published'),'check-on.png');
+				break;
+			case 0:
+				$img_status = sprintf($img,__('Unpublished'),'check-off.png');
+				break;
+			case -1:
+				$img_status = sprintf($img,__('Pending'),'check-wrn.png');
+				break;
+			case -2:
+				$img_status = sprintf($img,__('Junk'),'junk.png');
+				break;
+		}
+
+		echo
+		'<tr class="line'.($rs->comment_status != 1 ? ' offline' : '').'"'.
+		' id="c'.$rs->comment_id.'">'.
+
+		'<td class="nowrap">'.
+		($has_action ? form::checkbox(array('comments[]'),$rs->comment_id,isset($comments[$rs->comment_id]),'','',0,'title="'.($tb ? __('select this trackback') : __('select this comment')).'"') : '').'</td>'.
+		'<td class="maximal">'.html::escapeHTML($rs->comment_author).'</td>'.
+		'<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$rs->comment_dt).'</td>'.
+		'<td class="nowrap"><a href="'.$core->adminurl->get("admin.comments",array('ip' => $rs->comment_ip)).'">'.$rs->comment_ip.'</a></td>'.
+		'<td class="nowrap status">'.$img_status.'</td>'.
+		'<td class="nowrap status"><a href="'.$comment_url.'">'.
+		'<img src="images/edit-mini.png" alt="" title="'.__('Edit this comment').'" /> '.__('Edit').'</a></td>'.
+
+		'</tr>';
+	}
+
+	echo '</table></div>';
+};
+
 /* Post form if we can edit post
 -------------------------------------------------------- */
@@ -533,5 +615,5 @@
 					__('Accept comments').'</label></p>'.
 					($core->blog->settings->system->allow_comments ?
-						(isContributionAllowed($post_id,strtotime($post_dt),true) ?
+						($isContributionAllowed($post_id,strtotime($post_dt),true) ?
 							'' :
 							'<p class="form-note warn">'.
@@ -543,5 +625,5 @@
 					__('Accept trackbacks').'</label></p>'.
 					($core->blog->settings->system->allow_trackbacks ?
-						(isContributionAllowed($post_id,strtotime($post_dt),false) ?
+						($isContributionAllowed($post_id,strtotime($post_dt),false) ?
 							'' :
 							'<p class="form-note warn">'.
@@ -678,5 +760,5 @@
 	echo '<h3>'.__('Comments').'</h3>';
 	if (!$comments->isEmpty()) {
-		showComments($comments,$has_action);
+		$showComments($comments,$has_action);
 	} else {
 		echo '<p>'.__('No comments').'</p>';
@@ -762,5 +844,5 @@
 
 	if (!$trackbacks->isEmpty()) {
-		showComments($trackbacks, $has_action, true);
+		$showComments($trackbacks, $has_action, true);
 	} else {
 		echo '<p>'.__('No trackback').'</p>';
@@ -830,85 +912,4 @@
 }
 
-# Controls comments or trakbacks capabilities
-function isContributionAllowed($id,$dt,$com=true)
-{
-	global $core;
-
-	if (!$id) {
-		return true;
-	}
-	if ($com) {
-		if (($core->blog->settings->system->comments_ttl == 0) ||
-			(time() - $core->blog->settings->system->comments_ttl*86400 < $dt)) {
-			return true;
-		}
-	} else {
-		if (($core->blog->settings->system->trackbacks_ttl == 0) ||
-			(time() - $core->blog->settings->system->trackbacks_ttl*86400 < $dt)) {
-			return true;
-		}
-	}
-	return false;
-}
-
-# Show comments or trackbacks
-function showComments($rs,$has_action,$tb=false)
-{
-	global $core;
-	echo
-	'<div class="table-outer">'.
-	'<table class="comments-list"><tr>'.
-	'<th colspan="2" class="first">'.__('Author').'</th>'.
-	'<th>'.__('Date').'</th>'.
-	'<th class="nowrap">'.__('IP address').'</th>'.
-	'<th>'.__('Status').'</th>'.
-	'<th>'.__('Edit').'</th>'.
-	'</tr>';
-	$comments = array();
-	if (isset($_REQUEST['comments'])) {
-		foreach ($_REQUEST['comments'] as $v) {
-			$comments[(integer)$v]=true;
-		}
-	}
-
-	while($rs->fetch())
-	{
-		$comment_url = $core->adminurl->get("admin.comment",array('id' => $rs->comment_id));
-
-		$img = '<img alt="%1$s" title="%1$s" src="images/%2$s" />';
-		switch ($rs->comment_status) {
-			case 1:
-				$img_status = sprintf($img,__('Published'),'check-on.png');
-				break;
-			case 0:
-				$img_status = sprintf($img,__('Unpublished'),'check-off.png');
-				break;
-			case -1:
-				$img_status = sprintf($img,__('Pending'),'check-wrn.png');
-				break;
-			case -2:
-				$img_status = sprintf($img,__('Junk'),'junk.png');
-				break;
-		}
-
-		echo
-		'<tr class="line'.($rs->comment_status != 1 ? ' offline' : '').'"'.
-		' id="c'.$rs->comment_id.'">'.
-
-		'<td class="nowrap">'.
-		($has_action ? form::checkbox(array('comments[]'),$rs->comment_id,isset($comments[$rs->comment_id]),'','',0,'title="'.($tb ? __('select this trackback') : __('select this comment')).'"') : '').'</td>'.
-		'<td class="maximal">'.html::escapeHTML($rs->comment_author).'</td>'.
-		'<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$rs->comment_dt).'</td>'.
-		'<td class="nowrap"><a href="'.$core->adminurl->get("admin.comments",array('ip' => $rs->comment_ip)).'">'.$rs->comment_ip.'</a></td>'.
-		'<td class="nowrap status">'.$img_status.'</td>'.
-		'<td class="nowrap status"><a href="'.$comment_url.'">'.
-		'<img src="images/edit-mini.png" alt="" title="'.__('Edit this comment').'" /> '.__('Edit').'</a></td>'.
-
-		'</tr>';
-	}
-
-	echo '</table></div>';
-}
-
 dcPage::helpBlock('core_post','core_trackbacks','core_wiki');
 dcPage::close();
Index: admin/preferences.php
===================================================================
--- admin/preferences.php	(revision 3497)
+++ admin/preferences.php	(revision 3499)
@@ -44,4 +44,5 @@
 $user_ui_hidemoreinfo = $core->auth->user_prefs->interface->hidemoreinfo;
 $user_ui_htmlfontsize = $core->auth->user_prefs->interface->htmlfontsize;
+$user_ui_dynfontsize = $core->auth->user_prefs->interface->dynfontsize;
 if ($core->auth->isSuperAdmin()) {
 	$user_ui_hide_std_favicon = $core->auth->user_prefs->interface->hide_std_favicon;
@@ -242,4 +243,5 @@
 		$core->auth->user_prefs->interface->put('hidemoreinfo',!empty($_POST['user_ui_hidemoreinfo']),'boolean');
 		$core->auth->user_prefs->interface->put('htmlfontsize',$_POST['user_ui_htmlfontsize'],'string');
+		$core->auth->user_prefs->interface->put('dynfontsize',!empty($_POST['user_ui_dynfontsize']),'boolean');
 		if ($core->auth->isSuperAdmin()) {
 			# Applied to all users
@@ -517,5 +519,10 @@
 
 '<p><label for="user_ui_htmlfontsize" class="classic">'.__('Font size:').'</label>'.' '.
-form::combo('user_ui_htmlfontsize',$htmlfontsize_combo,$user_ui_htmlfontsize).'</p>';
+form::combo('user_ui_htmlfontsize',$htmlfontsize_combo,$user_ui_htmlfontsize).'</p>'.
+
+'<p><label for="user_ui_dynfontsize" class="classic">'.
+form::checkbox('user_ui_dynfontsize',1,$user_ui_dynfontsize).' '.
+__('Activate adpative font size').'</label></p>'.
+'<p class="clear form-note">'.__('If checked, font size will vary depending on viewport size (from 12px to 16px with default font size selected).').'</p>';
 
 echo
@@ -680,11 +687,9 @@
 echo '<h5 class="pretty-title">'.__('Other available favorites').'</h5>';
 $count = 0;
-function cmp($a,$b) {
-    if ($a['title'] == $b['title']) {
-        return 0;
-    }
-    return ($a['title'] < $b['title']) ? -1 : 1;
-}
-uasort($avail_fav,'cmp');
+uasort($avail_fav,function($a,$b) {
+	return strcoll(
+		strtolower(dcUtils::removeDiacritics($a['title'])),
+		strtolower(dcUtils::removeDiacritics($b['title'])));
+});
 
 foreach ($avail_fav as $k => $v) {
Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 3492)
+++ inc/admin/lib.dc.page.php	(revision 3509)
@@ -124,4 +124,6 @@
 			if (!is_null($core->blog->host)) {
 				$csp['default-src'] .= ' '.parse_url($core->blog->host,PHP_URL_HOST);
+				$csp['script-src'] .= ' '.parse_url($core->blog->host,PHP_URL_HOST);
+				$csp['style-src'] .= ' '.parse_url($core->blog->host,PHP_URL_HOST);
 			}
 			# Cope with media display in media manager (via public URL)
@@ -207,5 +209,6 @@
 		"</head>\n".
 		'<body id="dotclear-admin'.
-		($safe_mode ? ' safe-mode' : '').'" class="no-js">'."\n".
+		($safe_mode ? ' safe-mode' : '').'" class="no-js'.
+		($core->auth->user_prefs->interface->dynfontsize ? ' responsive-font' : '').'">'."\n".
 
 		'<ul id="prelude">'.
@@ -460,5 +463,6 @@
 		echo
 		"</head>\n".
-		'<body id="dotclear-admin" class="popup">'."\n".
+		'<body id="dotclear-admin" class="popup'.
+		($core->auth->user_prefs->interface->dynfontsize ? ' responsive-font' : '').'">'."\n".
 
 		'<h1>'.DC_VENDOR_NAME.'</h1>'."\n";
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 3485)
+++ inc/prepend.php	(revision 3487)
@@ -144,5 +144,5 @@
 # Constants
 define('DC_ROOT',path::real(dirname(__FILE__).'/..'));
-define('DC_VERSION','2.11.2');
+define('DC_VERSION','2.12-dev');
 define('DC_DIGESTS',dirname(__FILE__).'/digests');
 define('DC_L10N_ROOT',dirname(__FILE__).'/../locales');
Index: inc/public/class.dc.template.php
===================================================================
--- inc/public/class.dc.template.php	(revision 3461)
+++ inc/public/class.dc.template.php	(revision 3479)
@@ -2930,5 +2930,6 @@
 
 		if (isset($attr['blog_lang'])) {
-			$if[] = "\$core->blog->settings->system->lang == '".addslashes($attr['blog_lang'])."'";
+			$sign = (boolean) $attr['blog_lang'] ? '!' : '=';
+			$if[] = "\$core->blog->settings->system->lang ".$sign."= '".addslashes($attr['blog_lang'])."'";
 		}
 
Index: plugins/tags/inc/tags.behaviors.php
===================================================================
--- plugins/tags/inc/tags.behaviors.php	(revision 3448)
+++ plugins/tags/inc/tags.behaviors.php	(revision 3488)
@@ -198,5 +198,5 @@
 					"text_choose : '".html::escapeJS(__('Choose from list'))."',\n".
 					"text_all : '".html::escapeJS(__('all'))."',\n".
-					"text_separation : '".html::escapeJS(__('Enter tags separated by coma'))."',\n".
+					"text_separation : '".html::escapeJS(__('Enter tags separated by comma'))."',\n".
 				"};\n".
 				"</script>\n".
@@ -319,5 +319,5 @@
 			"text_choose : '".html::escapeJS(__('Choose from list'))."',\n".
 			"text_all : '".html::escapeJS(__('all'))."',\n".
-			"text_separation : '".html::escapeJS(__('Enter tags separated by coma'))."',\n".
+			"text_separation : '".html::escapeJS(__('Enter tags separated by comma'))."',\n".
 		"};\n".
 		"</script>\n".
